#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>
#include <errno.h>
#include "toolkit.h"
#include "tine.h"
#include "cdi.h"
#include "tinecdi.h"
#include "cdiCanLib.h"

int cdiInitCan(void)
{
  int cc = 0;
  if ((cc=cdiRegisterBusFilter(CAN_LIB_NAME,filterCanbus)) != 0 ) goto err;
  if ((cc=cdiRegisterBusConfiguration(CAN_LIB_NAME,configCanCard)) != 0) goto err;
  if ((cc=cdiRegisterBusInitialization(CAN_LIB_NAME,initCanLineForCDI)) != 0 ) goto err;
  if ((cc=cdiRegisterBusHandler(CAN_LIB_NAME,execCanbus)) != 0 ) goto err;
  if ((cc=cdiRegisterBusCleanup(CAN_LIB_NAME,terminateCanLine)) != 0 ) goto err;
  if ((cc=cdiRegisterBusScanner(CAN_LIB_NAME,canScanFcn)) != 0 ) goto err;
err:
  if (cc) cdilog("%s : failure in bus registration %s",erlst[cc], CAN_LIB_NAME);
  return cc;
}

BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{
  int i;
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:  // DLL being loaded
      cdiInitCan();
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:  // DLL being unloaded
      for (i=1; i<=MAX_NUMBER_CAN_LINES; i++) terminateCanLine(i);
      break;
  }
  return (TRUE);
}
