/** \file listener.h
 * \brief TINE static listener documentation 
 *
 */
#ifndef LISTENER_H_
#define LISTENER_H_

#include "project.def"
#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#define ALLOWED_IDLE_TIME 300
typedef struct cdiListenerStruct
{
  char devName[64];
  char devProperty[32];
  DTYPE dout;
  DTYPE din;
  BYTE *rbbuf;
  BYTE *outbuf;
  BYTE *inbuf;
  int mlid;
  int lid;         /* link id */
  int status;
  int pollrate;
  double timestamp;
  struct cdiListenerStruct *nxt;
} cdiListener;

#ifndef MAX_NUM_LISTENERS
#define MAX_NUM_LISTENERS 1000
#endif

extern cdiListener **cdiListenerTable;
extern int nCdiListeners;

int stopListener(cdiListener *ml);
cdiListener *startListener(char *devName,char *devProperty,DTYPE *dout,DTYPE *din,int pollrate,int flags);
int stopListener(cdiListener *ml);
cdiListener *getListener(char *devName,char *devProperty,DTYPE *dout,DTYPE *din);
int getDataFromListener(char *devName,char *devProperty,DTYPE *dout,DTYPE *din,double *dTime,int rate,int flags);
int cdiDumpListeners(int i1,int i2,int i3,int i4);
extern cdiListener *cdiListeners;
extern int nListeners;
extern int startListenerCompCode;

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* LISTENER_H_ */
