/********************************************************/
/* Common Device Interface to bus definition file */
/* ------------ cdi_bus.h --------------- */
/********************************************************/

#define u16 unsigned short

#ifdef CDI_CAN
// init
extern int configCanCard(void); // load Can card information into memory
extern int initCanLine(int line, int *parameters, void (*callBack)(int, char *, int, int, int, int, int), int cdiLine, int numberDevices);
extern int terminateCanLine(int line);
extern int canSend(int line, short nodeId, short canOpenId, short length, char *data, short ObjNum, short subIndex, short wFlag);

#endif

#ifdef CDI_RS232
// init
extern int openSerialPort(int channelNumber, int *parameters, void (*callBack)(int, char *, int), int cdiLine);
extern int closeSerialPort(int channelNumber);
extern int sendSerialPort(int channelNumber, char *psOutput);
//extern int receiveSerialPortString(int channelNumber, char *pString);

#endif

#ifdef CDI_SEDAC

#define READ 1 // for sedac input parameter
#define WRITE -1

// init
extern int initSedac(int ln);
extern int exitSedac(int ln);

// group read-write
extern int sedacCmp(u16 ln, u16 crate, u16 subadd, int RWF, u16 *data, int nwords);
extern int sedac(u16 ln, u16 crate, u16 subadd, int RWF, u16 *data, int nwords);
extern int nsedac(u16 ln, u16 *crate, u16 *subadd, int *RWF, u16 *data, int nwords);

// single read-write
extern int wsedac(u16 ln, u16 crate, u16 subadd, u16 data);
extern int rsedac(u16 ln, u16 crate, u16 subadd, u16 *data);

// find sub or crate address
extern int F_addr(int *naddr, int rwflag, u16 ln, u16 crate);
extern int F_crates(int *ncrates, int rwflag, u16 ln);
#endif
