#ifndef CDI_TINELIB_H
#define CDI_TINELIB_H
#include "rpctypes.h"
#include "errors.h"
#include "cdi.h"
#include "cdieqm.h"

#define TEMPLATE_RECORD_GAP 100
#define MAX_ERROR_LIST_SIZE 2000
extern int cdiAddrDbSize;

typedef struct extCdiPropertyStruct
{
  char prp[32];
  char tag[16];
  NAME16 *devs;
  int ndevs;
  int  fmt;
  int  id;
  int  isContiguous;
} ExtCdiProperty;
extern ExtCdiProperty *extCdiPrps;
extern int gNumExtCdiProperties;

CDI_EXPORT int cdiExecLinkEx(
  char *devName,     /* device name */
  char *devProperty, /* "READ", "WRITE", "READWRITE", "WRITEREAD" */
  DTYPE *dout,       /* output data pointer, type, and length (type is always UINT8, UINT16, UINT32 ?) */
  DTYPE *din,        /* input data pointer, type, and length (type is always UINT8, UINT16, UINT32 ?) */
  short access,      /* READ, WRITE are the only TINE access bits relevant here */
  UINT16 timeout     /* timeout in msec. */
);

CDI_EXPORT int cdiAttachLinkEx(
  char *devName,     /* device name */
  char *devProperty, /* "READ", "WRITE", "READWRITE", "WRITEREAD" */
  DTYPE *dout,       /* output data pointer, type, and length (type is always UINT8, UINT16, UINT32 ?) */
  DTYPE *din,        /* input data pointer, type, and length (type is always UINT8, UINT16, UINT32 ?) */
  short access,      /* READ, WRITE are the only TINE access bits relevant here */
  int pollingRate,   /* polling rate in msec. */
  void (*callback)(int,int), /* callback routine */
  int mode,          /* polling mode (SINGLE, POLL, REFRESH, etc.) */
  UINT32 callbackID  /* callback ID */
);

CDI_EXPORT int cdiAttachLinkHookFcn(
  char *devName,     /* device name */
  char *devProperty, /* "READ", "WRITE", "READWRITE", "WRITEREAD" */
  DTYPE *dout,       /* output data pointer, type, and length (type is always UINT8, UINT16, UINT32 ?) */
  DTYPE *din,        /* input data pointer, type, and length (type is always UINT8, UINT16, UINT32 ?) */
  short access,      /* READ, WRITE are the only TINE access bits relevant here */
  int pollingRate,   /* polling rate in msec. */
  void (*callback)(int,int), /* callback routine */
  int mode,          /* polling mode (SINGLE, POLL, REFRESH, etc.) */
  UINT32 callbackID  /* callback ID */
);

CDI_EXPORT int cdiExecLinkHookFcn(
  char *devName,     /* device name */
  char *devProperty, /* "READ", "WRITE", "READWRITE", "WRITEREAD" */
  DTYPE *dout,       /* output data pointer, type, and length (type is always UINT8, UINT16, UINT32 ?) */
  DTYPE *din,        /* input data pointer, type, and length (type is always UINT8, UINT16, UINT32 ?) */
  short access,      /* READ, WRITE are the only TINE access bits relevant here */
  UINT16 timeout     /* timeout in msec. */
);

CDI_EXPORT void cdilog(char *text,...);
CDI_EXPORT void rotateLogFile(void);
CDI_EXPORT void cdiSetDataByteMask(void *dataMask,int sizeInBytes);
CDI_EXPORT void *cdiGetDataByteMask(void);
CDI_EXPORT char *cdiGetFullDeviceName(char *devName);
CDI_EXPORT char *getCdiLinkName(char *devName,char *lnkName);
CDI_EXPORT int cdiCloseLink(int id);
CDI_EXPORT void initTineCDI(void);
CDI_EXPORT int cdiRegisterDevice(
  char *devName, int devNumber, char *lngName, char *devDesc, 
  int cdiLine, int cdiIndex, int address, int subAddress,int *devParameters
);
CDI_EXPORT int readCdiDataBase(void);
CDI_EXPORT int readCdiManifest(void);
CDI_EXPORT short getCdiFormat(short tineFormat);
short getBaseFormat(short tineFormat,int *needsErrList,int *needsNameList);
short getCdiBaseFormat(short tineFormat);
int cdiSystemInitialization(void);
void fixCdiRepository(void);
void remapCdiDeviceAndProperty(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access);

#ifndef ccerr
# define ccerr(e) {cc = e; goto err; }
#endif

#endif /* CDI_TINELIB_H */

